// CHECKSTYLE:OFF
/**
 * Source code generated by Fluent Builders Generator
 * Do not modify this file
 * See generator home page at: http://code.google.com/p/fluent-builders-generator-eclipse-plugin/
 */

package nl.krocket.ocr.core.model.builders;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import nl.krocket.ocr.core.model.BaseImage;
import nl.krocket.ocr.core.model.ProcesStatus;
import nl.krocket.ocr.core.model.UserInfo;

public class BaseImageBuilder extends BaseImageBuilderBase<BaseImageBuilder> {
	public static BaseImageBuilder baseImage() {
		return new BaseImageBuilder();
	}

	public BaseImageBuilder() {
		super(new BaseImage());
	}

	public BaseImage build() {
		return getInstance();
	}
}

class BaseImageBuilderBase<GeneratorT extends BaseImageBuilderBase<GeneratorT>> {
	private BaseImage instance;

	protected BaseImageBuilderBase(BaseImage aInstance) {
		instance = aInstance;
	}

	protected BaseImage getInstance() {
		return instance;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withProcesStatus(ProcesStatus aValue) {
		instance.setProcesStatus(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withUserInfo(UserInfo aValue) {
		instance.setUserInfo(aValue);

		return (GeneratorT) this;
	}

	public UserInfoUserInfoBuilder withUserInfo() {
		UserInfo obj = new UserInfo();

		withUserInfo(obj);

		return new UserInfoUserInfoBuilder(obj);
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withBaseImageId(Long aValue) {
		instance.setBaseImageId(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withCreationDate(Date aValue) {
		instance.setCreationDate(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withFileName(String aValue) {
		instance.setFileName(aValue);

		return (GeneratorT) this;
	}

	@SuppressWarnings("unchecked")
	public GeneratorT withFileDirectory(String aValue) {
		instance.setFileDirectory(aValue);

		return (GeneratorT) this;
	}
	
	@SuppressWarnings("unchecked")
	public GeneratorT withType(String aValue) {
		instance.setType(aValue);

		return (GeneratorT) this;
	}

	public class UserInfoUserInfoBuilder extends
			UserInfoBuilderBase<UserInfoUserInfoBuilder> {
		public UserInfoUserInfoBuilder(UserInfo aInstance) {
			super(aInstance);
		}

		@SuppressWarnings("unchecked")
		public GeneratorT endUserInfo() {
			return (GeneratorT) BaseImageBuilderBase.this;
		}
	}

	public static class UserInfoBuilderBase<GeneratorT extends UserInfoBuilderBase<GeneratorT>> {
		private UserInfo instance;

		protected UserInfoBuilderBase(UserInfo aInstance) {
			instance = aInstance;
		}

		protected UserInfo getInstance() {
			return instance;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withBaseImage(Set<BaseImage> aValue) {
			instance.setBaseImage(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withAddedBaseImageElement(BaseImage aValue) {
			if (instance.getBaseImage() == null) {
				instance.setBaseImage(new HashSet<BaseImage>());
			}

			((HashSet<BaseImage>) instance.getBaseImage()).add(aValue);

			return (GeneratorT) this;
		}

		public AddedBaseImageElementBaseImageBuilder withAddedBaseImageElement() {
			BaseImage obj = new BaseImage();

			withAddedBaseImageElement(obj);

			return new AddedBaseImageElementBaseImageBuilder(obj);
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withUserId(Long aValue) {
			instance.setUserId(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withUserName(String aValue) {
			instance.setUserName(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withPassword(String aValue) {
			instance.setPassword(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withRole(String aValue) {
			instance.setRole(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withCreationDate(Date aValue) {
			instance.setCreationDate(aValue);

			return (GeneratorT) this;
		}

		@SuppressWarnings("unchecked")
		public GeneratorT withLastLogin(Date aValue) {
			instance.setLastLogin(aValue);

			return (GeneratorT) this;
		}

		public class AddedBaseImageElementBaseImageBuilder extends
				BaseImageBuilderBase<AddedBaseImageElementBaseImageBuilder> {
			public AddedBaseImageElementBaseImageBuilder(BaseImage aInstance) {
				super(aInstance);
			}

			@SuppressWarnings("unchecked")
			public GeneratorT endBaseImageElement() {
				return (GeneratorT) UserInfoBuilderBase.this;
			}
		}
	}
}
